﻿Imports AxMapWinGIS
Imports MapWinGIS

Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim sf As New Shapefile
        sf.Open("L:\MapTest\Data\SUBDIV.shp")
        AxMap1.AddLayer(sf, True)
        Dim iErr As Integer = sf.LastErrorCode
        If iErr > 0 Then
            Debug.WriteLine("Shapefile Open Error: " + iErr.ToString + " " + sf.ErrorMsg(iErr))
        End If
    End Sub
    Private Sub CmdStartEdit_Click(sender As Object, e As EventArgs) Handles CmdStartEdit.Click
        Dim sf As Shapefile = AxMap1.get_Shapefile(0)
        sf.InteractiveEditing = True
        sf.StartEditingShapes(True)
        AxMap1.CursorMode = tkCursorMode.cmEditShape
        Dim iErr As Integer = sf.LastErrorCode
        If iErr > 0 Then
            Debug.WriteLine("Shapefile Start Error: " + iErr.ToString + " " + sf.ErrorMsg(iErr))
        End If
        CmdAddShapes.Enabled = True
        CmdEditShapes.Enabled = True
        CmdSaveEdit.Enabled = True
        CmdStartEdit.Enabled = False
    End Sub

    Private Sub CmdSaveEdit_Click(sender As Object, e As EventArgs) Handles CmdSaveEdit.Click
        Dim sf As Shapefile = AxMap1.get_Shapefile(0)
        sf.InteractiveEditing = False
        sf.StopEditingShapes(True, True)
        Dim iErr As Integer = sf.LastErrorCode
        If iErr > 0 Then
            Debug.WriteLine("Shapefile Save Error: " + iErr.ToString + " " + sf.ErrorMsg(iErr))
            sf.StartEditingShapes(True)
            sf.StopEditingShapes(True, True)
            iErr = sf.LastErrorCode
            If iErr > 0 Then
                Debug.WriteLine("Shapefile Save Error: " + iErr.ToString + " " + sf.ErrorMsg(iErr))
            End If
        End If
        CmdAddShapes.Enabled = False
        CmdEditShapes.Enabled = False
        CmdSaveEdit.Enabled = False
        CmdStartEdit.Enabled = True
        AxMap1.CursorMode = tkCursorMode.cmSelection
    End Sub
    Private Sub CmdEditShapes_Click(sender As Object, e As EventArgs) Handles CmdEditShapes.Click
        AxMap1.CursorMode = tkCursorMode.cmEditShape
    End Sub
    Private Sub CmdAddShapes_Click(sender As Object, e As EventArgs) Handles CmdAddShapes.Click
        AxMap1.CursorMode = tkCursorMode.cmAddShape
    End Sub
    Private Sub AxMap1_ChooseLayer(sender As Object, e As _DMapEvents_ChooseLayerEvent) Handles AxMap1.ChooseLayer
        e.layerHandle = 0
    End Sub
    Private Sub AxMap1_ValidateShape(sender As Object, e As _DMapEvents_ValidateShapeEvent) Handles AxMap1.ValidateShape
        If e.shape.IsValid Then
            e.cancel = False
        Else
            e.cancel = True
            Debug.WriteLine("Shape validation failed: " + e.shape.LastErrorCode.ToString + ": " + e.shape.IsValidReason)
        End If
    End Sub
End Class
